'Author..... CrustCrawler Inc. (Mike Gebhard)
'main method added by Dave Ratcliff 1-6-10
CON
   _clkmode = xtal1 + pll16x
   _xinfreq = 5_000_000
   #1, i_Ping, i_ReadData, i_WriteData, i_RegWrite, i_Action, i_Reset, #131, i_SyncWrite  
   dyn = 0
   led = 2
   
var
  byte  byteArray[50]
  
obj
  dy : "dynamixelasmbus_v0.37_04272008"
  tv : "vga_text"
  ms : "mouse"
  
pub main | g,i,x,y,z,x1,y1,z1
  tv.start(16)                 'start vga display
  ms.start(24,25)              'start mouse
  dy.start(dyn,1_000_000)      'start dynamixel bus communications
  g := 512                     'set initial x,y,z,g positions
  x := 512
  y := 512
  z := 512
  word[@bytearray[0]] := 100   'slow moving speed all servos   
  repeat i from 1 to 4                              
    writedata(i,32,2)
                               
  word[@bytearray[0]] := 512   'center all servos       
  repeat i from 1 to 4                              
    writedata(i,30,2)
    
  waitcnt(200_000_000 + cnt)   'delay to wait for servos to physically center
                                    
  word[@bytearray[0]] := 500   'set servo moving speed all servos 
  repeat i from 1 to 4                            
    writedata(i,32,2)                             

  repeat
    x1 := ms.abs_x + x               'get mouse x and calculate x position
    y1 := ms.abs_y + y               'get mouse y and calculate y position
    z1 := z + (ms.abs_z * 5)         'get mouse scroll wheel and calculate z position
    x1 := 260 #> x1 <# 1023          'set x limits     
    y1 := 240 #> y1 <# 620           'set y limits     
    z1 := 70 #> z1 <# 910            'set z limits      
    word[@bytearray[0]] := x1        'set x servo position to mouse x position
    writedata(1,30,2)
    word[@bytearray[0]] := y1        'set y servo position to mouse y position
    writedata(2,30,2)                    
    word[@bytearray[0]] := z1        'set z servo position to mouse scroll wheel
    writedata(3,30,2)                    
    if ms.buttons == 1               'if mouse left button - close gripper
      g := g + 5
    if ms.buttons == 2               'if mouse right button - open gripper
      g := g - 5
    g := 0 #> g <# 1023              'set gripper limits   
    word[@bytearray[0]] := g         'move gripper servo
    writedata(4,30,2)

    tv.out(1)                        'display x,y,z,g values
    tv.str(string("X = "))
    tv.dec(x1)
    tv.str(string("     ",13))
    tv.str(string("Y = "))
    tv.dec(y1)                  
    tv.str(string("     ",13))
    tv.str(string("Z = ")) 
    tv.dec(z1)                  
    tv.str(string("     ",13))
    tv.str(string("G = "))
    tv.dec(g)
    tv.str(string("     ",13)) 

PUB Ping(id) | mode, pl, cs, len
{{Ping(<id>}}
  len := $02
  cs := (id + len + i_Ping)^$FF
  dy.SetAxBuffer(0, $FF)
  dy.SetAxBuffer(1, $FF)
  dy.SetAxBuffer(2, id)
  dy.SetAxBuffer(3, len)
  dy.SetAxBuffer(4, i_Ping)
  dy.SetAxBuffer(5, cs)

  pl := len + $04
  mode := GetResponseMode(i_Ping)
  
  'Execute
  dy.ExecuteCommand(pl,mode)
  IsException
  SendResponseToDebug

PUB ReadData(id, startAddr, bytesToRead) | len, cs, pl, mode
{{ReadData(<id>, <start address>, <number of bytes to read>)}}
    
  len := $04
  cs := (id + len + i_ReadData + startAddr + bytesToRead)^$FF
    
  dy.SetAxBuffer(0, $FF)
  dy.SetAxBuffer(1, $FF)
  dy.SetAxBuffer(2, id)
  dy.SetAxBuffer(3, len)
  dy.SetAxBuffer(4, i_ReadData)
  dy.SetAxBuffer(5, startAddr)
  dy.SetAxBuffer(6, bytesToRead)
  dy.SetAxBuffer(7, cs)
  
  pl := len + $04
  mode := GetResponseMode(i_ReadData)
  
  'Execute
  dy.ExecuteCommand(pl, mode)
  IsException
  'SendResponseToDebug
  
PUB WriteData(id, startAddr, N) | len, pl, cs, mode, tempSum, idx, idx2
{{WriteData(<id>, <start address>, <number of bytes to write>)}} 
  'N+3 because you need to add the start address parameter
  len := N + 3
  idx := 0
  idx2 := 0
  tempSum := 0
  
  dy.SetAxBuffer(idx++, $FF)
  dy.SetAxBuffer(idx++, $FF)
  dy.SetAxBuffer(idx++, id)
  dy.SetAxBuffer(idx++, len)
  dy.SetAxBuffer(idx++, i_WriteData)
  dy.SetAxBuffer(idx++, startAddr)
  'get all data bytes to send
  repeat N
    tempSum += byteArray[idx2]
    dy.SetAxBuffer((idx), byteArray[idx2])
    idx++
    idx2++
    
  'CheckSum  
  cs := (id + len + i_WriteData + startAddr + tempSum)^$FF
  'Set checksum
  dy.SetAxBuffer((idx), cs)

  'Packet length and mode
  pl := len + $04
  mode := GetResponseMode(i_WriteData)
  
  'Execute
  dy.ExecuteCommand(pl, mode)
  IsException
  SendResponseToDebug
 

PUB RegWrite(id, startAddr, N)  | len, pl, cs, mode, tempSum, idx, idx2
{{
  RegWrite(<id>, <start address>, <number of bytes to write>)
  You must execute the Action command after the RegWrite command
}}
  'N+3 because you need to add the start address parameter
  len := N + 3
  idx := 0
  idx2 := 0
  tempSum := 0
  
  dy.SetAxBuffer(idx++, $FF)
  dy.SetAxBuffer(idx++, $FF)
  dy.SetAxBuffer(idx++, id)
  dy.SetAxBuffer(idx++, len)
  dy.SetAxBuffer(idx++, i_RegWrite)
  dy.SetAxBuffer(idx++, startAddr)
  'get all data bytes to send
  repeat N
    tempSum += byteArray[idx2]
    dy.SetAxBuffer((idx), byteArray[idx2])
    idx++
    idx2++
    
  'CheckSum  
  cs := (id + len + i_RegWrite + startAddr + tempSum)^$FF
  'Set checksum
  dy.SetAxBuffer((idx), cs)

  'Packet length and mode
  pl := len + $04
  mode := GetResponseMode(i_RegWrite)
  
  'Execute
  dy.ExecuteCommand(pl, mode)
  IsException
  

PUB Action | mode, pl, cs, len, id
  len := $02
  id := $FE
  cs := (id + len + i_Action)^$FF
  
  dy.SetAxBuffer(0, $FF)
  dy.SetAxBuffer(1, $FF)
  dy.SetAxBuffer(2, id)
  dy.SetAxBuffer(3, len)
  dy.SetAxBuffer(4, i_Action)
  dy.SetAxBuffer(5, cs)

  pl := len + $04
  mode := GetResponseMode(i_Action)
  
  'Execute
  dy.ExecuteCommand(pl,mode)  
  IsException

  
PUB SyncWrite(numDynamixels, startAddr, numBytes) | pl, cs, mode, tempSum, idx, idx2, id, len
{{SyncWrite(<length>,<start address>,<number if dynamixles>, <data lenght>)
number of dynamixels, # of bytes to write, starting address, data[]     }}
  idx := 0
  idx2 := 0
  tempSum := 0
  id := $FE
  len := ((numBytes + 1) * numDynamixels)
  
  dy.SetAxBuffer(idx++, $FF)
  dy.SetAxBuffer(idx++, $FF)
  dy.SetAxBuffer(idx++, id)
  'Half of the length equations was done above 
  dy.SetAxBuffer(idx++, len + 4)
  dy.SetAxBuffer(idx++, i_SyncWrite)
  dy.SetAxBuffer(idx++, startAddr)
  dy.SetAxBuffer(idx++, numBytes)
  'get all data bytes to send
  repeat len
    tempSum += byteArray[idx2]
    dy.SetAxBuffer((idx++), byteArray[idx2++])

  'CheckSum  
  cs := (id + (len + 4) + numBytes + i_SyncWrite + startAddr + tempSum)^$FF
  
  'Set checksum
  dy.SetAxBuffer((idx), cs)

  'Packet length and mode
  pl := len + 4 + 4
  
  mode := GetResponseMode(i_RegWrite)
  
  'Execute
  dy.ExecuteCommand(pl, mode)
  IsException
  
  
PUB Reset(id) | mode, pl, cs, len
  len := $02
  cs := (id + len + i_Reset)^$FF
  dy.SetAxBuffer(0, $FF)
  dy.SetAxBuffer(1, $FF)
  dy.SetAxBuffer(2, id)
  dy.SetAxBuffer(3, len)
  dy.SetAxBuffer(4, i_Reset)
  dy.SetAxBuffer(5, cs)

  pl := len + $04
  mode := GetResponseMode(i_Reset)
  
  'Execute
  dy.ExecuteCommand(pl,mode)
  IsException
  SendResponseToDebug
  

PRI GetResponseMode(instructionType) : mode
  case instructionType
    I_Ping          : mode := 1
    I_ReadData      : mode := 1
    I_WriteData     : mode := 1
    I_RegWrite      : mode := 2
    I_Action        : mode := 2
    I_Reset         : mode := 1
    I_SyncWrite     : mode := 2
    other           : mode := 0
   
PRI SendResponseToDebug | pl, idx
{{Output to VGA screen}}
 { pl :=  dy.GetAxBuffer($03) + 3
  repeat idx from 0 to pl 
    tv.hex(dy.GetAxBuffer(idx),2)
    tv.str(string(" "))
  tv.out(13) }
  
PRI RestartDynaBus
{{If all else fails hit the engineer switch to restart the DynaBus cog}}
  dy.Stop
  dy.Start(2, 1_000_000)
  
PRI IsException
{{Visual indicator
  Demo board LED 23 blinks after Tx operation
  A timeout causes LEDs 23, 22, then 21 to blink
  An offline situation causes LEDs 23, 22, 21 to blink
}}
    if dy.IsTimeout
      outa[led]~~
    elseif dy.IsBusoffline
      outa[led]~~
    else
      outa[led]~            